//
//  SLIBDebugItem.m
//  PeekIt II
//
//  Created by C.K. Haun on 1/2/13.
//  Copyright (c) 2013 Ravenware Industries LLC. All rights reserved.
//
#define __SLIBDBI__
#import "SLIBDebugItem.h"

@implementation SLIBDebugItem

-(id)init{
    self = [super initWithGRAValues:'DEBG' one:0 two:0 three:0];
    
    return self;
}

-(id)initWithType:(OSType) type andData:(id)inData{
    self =  [super initWithGRAValues:'DEBG' one:'????' two:'????' three:0];
    [    self setSLIBName: @"untitled debug item"];
    data=inData;
    
    
    
    return self;
    
}


-(id)initWithType:(OSType) type  andName:(NSString *)theName andData:(id)inData{
    self =  [super initWithGRAValues:'DEBG' one:'????' two:'????' three:0];
    [    self setSLIBName: theName];
    data=inData;
    
    
    
    return self;
    
}

-(id)initWithType:(OSType) type andSubtype:(OSType)subtype andName:(NSString *)name andData:(id)inData{
    self =  [super initWithGRAValues:'DEBG' one:type two:subtype three:0];
[    self setSLIBName:   name];
    data=inData;
    
    
    
    return self;

}
-(NSString *)nameStringFromItem{
    NSString *retVal ;
    retVal = self.name;
   
    return retVal;
}
-(NSString *)valueStringFromItem{
    NSString *retVal;
    NSNumber *num;
    switch (slibID->unitID.compare2){
        case 'INT ':
            case 'FLOA':
            num = data;
            retVal=[num stringValue];
        break;
            case 'RECT':
        {NSRect ret;
            [data getValue:&ret];
            retVal=@"X:";
            retVal= [retVal stringByAppendingFormat:@"%4.0f",ret.origin.x];
            retVal= [retVal stringByAppendingFormat:@" Y:%4.0f",ret.origin.y];
            retVal= [retVal stringByAppendingFormat:@"  wide::%4.0f",ret.size.width];
            retVal= [retVal stringByAppendingFormat:@"  high:%4.0f",ret.size.height];

            
        }
            break;
            case 'NSST':
            retVal=data;
            break;
    default:
        retVal = @"Unknown value";
        break;
    }
    return retVal;
}

+(void)safetadd:(NSNotification *)note{
    mGetMasterDebug;
    [gDBGlobals addToDebugText:note.object];
    
}

+(void)addsafely:(Ptr)A andLen:(NSUInteger)B{
    
    //    mGetMasterDebug;
    NSString *fool567 =  [[NSString alloc]initWithBytes:A length:B    encoding:NSASCIIStringEncoding]; SLIBDebugItem *j879jhHH2345 = [[SLIBDebugItem alloc]initWithType:'TEXT' andSubtype:'NSST' andName:@"NSString" andData:fool567];
    [self performSelectorOnMainThread:@selector(safetadd:) withObject:j879jhHH2345 waitUntilDone:NO];
}

@end
