//
//  SLIBDebugView.m
//  PeekIt II
//
//  Created by C.K. Haun on 1/2/13.
//  Copyright (c) 2013 Ravenware Industries LLC. All rights reserved.
//
#ifndef __FORIPHONE__

#import "SLIBDebugView.h"

@implementation SLIBDebugView
-(void)clear{
    
}

#if 0
-(id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
        nowColor=[NSColor blueColor];
        altnowColor = [NSColor redColor];
    }
    
    return self;
}

-(void)scoreCounter:(NSTimer *)oooo{
    [self setNeedsDisplay:YES];
}

-(void)clear{
    if(diid){
        [diid invalidate];
        diid=nil;
    } else{
    diid=	 [NSTimer scheduledTimerWithTimeInterval: 0.07 target:self selector:@selector(scoreCounter:) userInfo:nil repeats: YES];
    
    }
    [self setNeedsDisplay:YES ];
}

- (void)drawRect:(NSRect)dirtyRect
{
    // Drawing code here.
    [self drawGradientFlow:dirtyRect method:kGradientWithColorDrawing];
}

-(void)drawGradientFlow:(CGRect)rect method:(SCDrawingMode)method {
	CGContextRef	cg = (CGContextRef)[[NSGraphicsContext currentContext]
                                        graphicsPort];//UIGraphicsGetCurrentContext();
	CGColorSpaceRef myColorSpace = CGColorSpaceCreateDeviceRGB();
	int qq;
	size_t numComponents;
	CGGradientRef myGradient;
	size_t num_locations ;
	const CGFloat *compolist;
	
	CGFloat locations[] = { 0.0, .5,1.0 };
	CGFloat components[8] = { 1.0, 0.5, 0.4, 1.0,  // Start color
        0.0, 0.0, 0.0, 1.0 }; // End color
	CGColorRef startCol = [nowColor CGColor];
	numComponents = CGColorGetNumberOfComponents(startCol);
	compolist=CGColorGetComponents(startCol);
	if(numComponents < 4){  // vs
		for(qq=0;qq<4;qq++){
			components[qq] = *compolist;
		}
		components[3]=1;
		
	} else {
        for(qq=0;qq<numComponents;qq++){
            components[qq] = *compolist;
            compolist++;
        }}
	
    // same with alt color
	CGColorRef altCol;
	switch(method){
		case kGradientWithBlackDrawing:
            altCol= [[NSColor blackColor]  CGColor];
			
			break;
		case kGradientWithWhiteDrawing:
			altCol= [[NSColor whiteColor]  CGColor] ;
            
			break;
		case kGradientWithColorDrawing:
			altCol= [altnowColor CGColor];
            
			break;
	}
	numComponents = CGColorGetNumberOfComponents(altCol);
	compolist=CGColorGetComponents(altCol);
    
	switch(numComponents){
		case 2:
			for(qq=4;qq<7;qq++){
				components[qq] = *compolist;
			}
			components[7]=1;
			
			break;
		case 3:
			for(qq=4;qq<7;qq++){
				components[qq] = *compolist++;
			}
			components[7]=1;
			
			break;
		case 4:
			for(qq=4;qq<7;qq++){
				components[qq] = *compolist++;
			}
			components[7]=1;
			
			break;
	}
    
	locations[1] = gradCenter;
	if(dontAnimate == NO){
		CGFloat oldGradCenter = gradCenter;
        if(gradBackwards==FALSE){
            gradCenter = gradCenter +.02;
            if(gradCenter >.9){gradBackwards = TRUE;
                gradCenter = oldGradCenter;
                    altnowColor = mRandomNSColor;
                wideAdder=Choose(10);
                highAdder=Choose(10);
                pStartx=Choose (100);
                pStarty=Choose(1000);
            }
        } else {
            gradCenter = gradCenter -.02;
            if(gradCenter <.1){gradBackwards = FALSE;
                gradCenter = oldGradCenter;
                wideAdder=Choose(10);
                highAdder=Choose(10);
                pStartx=Choose (100);
                pStarty=Choose(1000);

                    nowColor = mRandomNSColor;

            }
            
        }} else {
            dontAnimate = NO;
        }
	num_locations = sizeof(locations)/sizeof(CGFloat);
    
	myGradient = CGGradientCreateWithColorComponents (myColorSpace, components,
													  locations, num_locations);
	CGPoint  myEndPoint;
	if(subDrawMode == kRectGradient){
        
        myStartPoint.x = 0.0;
        myStartPoint.y = 0.0+pStarty;
        myEndPoint.x = rect.size.width;
        myEndPoint.y =rect.size.height-pStarty  ;
        
        CGContextDrawLinearGradient (cg, myGradient, myStartPoint, myEndPoint, cirGradOption);
	}else{
        
		myEndPoint.y = 3.3;
		CGContextDrawRadialGradient(cg,
                                    myGradient,myStartPoint, rect.size.width,
                                    myEndPoint,rect.size.width+baby,cirGradOption);
	}
	CGGradientRelease(myGradient);
}



#endif
@end
#endif

